package com.kingdee.shr.custom.service;

import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;

import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.dao.ormapping.ObjectUuidPK;
import com.kingdee.bos.metadata.entity.EntityViewInfo;
import com.kingdee.bos.metadata.entity.FilterInfo;
import com.kingdee.bos.metadata.entity.FilterItemInfo;
import com.kingdee.bos.metadata.entity.SelectorItemCollection;
import com.kingdee.bos.metadata.query.util.CompareType;
import com.kingdee.eas.basedata.org.AdminOrgUnitCollection;
import com.kingdee.eas.basedata.org.AdminOrgUnitFactory;
import com.kingdee.eas.basedata.org.AdminOrgUnitInfo;
import com.kingdee.eas.basedata.org.IAdminOrgUnit;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.util.ToolUtils;
import com.kingdee.eas.util.app.DbUtil;
import com.kingdee.jdbc.rowset.IRowSet;
import com.kingdee.util.StringUtils;

public class GetOrgUtils {
	
	/**
	 * ȡ֯
	 * @param ctx
	 * @return
	 */
	public static String getRootOrg(Context ctx) {
		String orgId = "";
		try {
			String sql = "select fid from T_ORG_Admin  where FLEVEL  = 1 ";
			IRowSet executeQuery = DbUtil.executeQuery(ctx, sql);
			while(executeQuery.next()) {
				orgId = executeQuery.getString("fid");
			}
		} catch (SQLException e) {
			e.printStackTrace();
		} catch (BOSException e) {
			e.printStackTrace();
		}
		return orgId;
	}
	
	/**
	 * ȡ
	 * checkType1ʱ,ѯ¼֯;
	 * ,ֻѯֱ¼֯;
	 * @param ctx
	 * @param orgId
	 * @param checkType
	 * @return
	 * @throws BOSException
	 * @throws EASBizException
	 */
	public  static  int  getPersonCount(Context ctx ,String orgId,String checkType) throws BOSException, EASBizException {
		String filterStr = " and topp.FAdminOrgUnitID = '"+orgId+"'   ";
		try {
			if(!StringUtils.equals("1", checkType)) {
				List<String> orgIds = getAllSubOrg(ctx, orgId);
				filterStr = " and topp.FAdminOrgUnitID in ( "+ToolUtils.aryToStr(orgIds,true)+" )";
			} 
			String pinSql = pinPersonSql( "count",filterStr);
			IRowSet rs = DbUtil.executeQuery(ctx, pinSql);
			while(rs.next()) {
				return  rs.getInt("pcount");
			}
		} catch (SQLException e) {
			e.printStackTrace();
		}
		return 0;
		
		
	}
	
	public static List<String> getAllSubOrg( Context ctx ,String orgId ) throws EASBizException, BOSException {
		if(StringUtils.equals("1", orgId)){
			orgId  =  getRootOrg(ctx);
		}
		List<String> orgIds = new ArrayList();
		SelectorItemCollection sic =new SelectorItemCollection();
        sic.add("id");
        sic.add("longNumber");
        sic.add("name");
		IAdminOrgUnit iAdminOrgUnit = AdminOrgUnitFactory.getLocalInstance(ctx);
		AdminOrgUnitInfo orgInfo = iAdminOrgUnit.getAdminOrgUnitInfo(new ObjectUuidPK(orgId),sic);
		
		if(null!=orgInfo &&!StringUtils.isEmpty(orgInfo.getLongNumber())) {
			String longNum = orgInfo.getLongNumber();
			//ȡ¼֯
//			String[] longNumStrs = longNum.split("!");
//			Set<String> numsSet  = new HashSet<String>();
//			numsSet.addAll(Arrays.asList(longNumStrs));
			EntityViewInfo view =  new EntityViewInfo();
			FilterInfo filter = new FilterInfo();
			filter.getFilterItems().add(new FilterItemInfo("longnumber",longNum+"%",CompareType.LIKE));
			filter.getFilterItems().add(new FilterItemInfo("isSealUp", false ,CompareType.EQUALS));
			view.setFilter(filter);
			view.setSelector(sic);
			AdminOrgUnitCollection col = iAdminOrgUnit.getAdminOrgUnitCollection(view);
			if(null!=col && col.size()>0) {
				for (int k = 0; k < col.size(); k++) {
					AdminOrgUnitInfo adminOrg = col.get(k);
					String adminId = StringUtils.cnulls( adminOrg.getString("id"));
					orgIds.add(adminId) ;
				}
			}
		}
		return orgIds;
	}
	
	/**
	 * ȡԱ
	 * @param ctx
	 * @param perName
	 * @return
	 * @throws BOSException
	 * @throws EASBizException
	 */
	public static List getPersonFromName(Context ctx ,String orgId,String perName) throws BOSException, EASBizException {
		if(StringUtils.equals("1", orgId)){
			orgId  =  getRootOrg(ctx);
		}
		String filterStr = " and ( pers.fname_l2  like '%"+perName+"%'  or  pers.fnumber like '%"+perName+"%' ) " ;
		if(!StringUtils.isEmpty(orgId)) {
			filterStr = " and ( pers.fname_l2  like '%"+perName+"%'  or  pers.fnumber like '%"+perName+"%' ) " 
					+ " and topp.FAdminOrgUnitID  = '"+orgId+"'   ";
		}
		return assemPersonData(ctx, filterStr);
	}
	
	/**
	 * ֯ȡԱ
	 * checkType = 0;е¼; 1,ֱֻ¼
	 * @param ctx
	 * @param perName
	 * @return
	 * @throws BOSException
	 * @throws EASBizException
	 */
	public static List getPersonFromOrg(Context ctx ,String orgId,String checkType) throws BOSException, EASBizException {
		if(StringUtils.equals("1", orgId)){
			orgId  =  getRootOrg(ctx);
		}
		String filterStr = " and topp.FAdminOrgUnitID  = '"+orgId+"'   ";
		if(!StringUtils.equals(checkType, "1")) {
			List<String> orgIds = getAllSubOrg(ctx, orgId);
			String aryToStr = ToolUtils.aryToStr(orgIds,true);
			filterStr = " and topp.FAdminOrgUnitID in ("+aryToStr+")   ";
		}
		return assemPersonData(ctx, filterStr);
		
	}
	
	public static  List  assemPersonData(Context ctx, String filterStr) throws BOSException{
		List<Map> personList = new ArrayList();
		try {
			String pinSql = pinPersonSql( "info",filterStr);
			IRowSet rs = DbUtil.executeQuery(ctx, pinSql);
			while(rs.next()) {
				String fid = StringUtils.cnulls(rs.getString("fid"));
				String name = StringUtils.cnulls(rs.getString("name"));
				String number = StringUtils.cnulls(rs.getString("number"));
				HashMap<String,String> map = new HashMap();
				map.put("fid", fid);
				map.put("name", name);
				map.put("number", number);
				map.put("posname", StringUtils.cnulls(rs.getString("posname")));
				map.put("depname", StringUtils.cnulls(rs.getString("depname")));
				personList.add(map);
			}
		} catch (SQLException e) {
			e.printStackTrace();
		}
		return personList;
	}
	
 
	
	
	/**
	 * 
	 * @param type
	 * info ԱϢ;
	 * count Ա
	 * adminPerson ÿ֯µ;
	 * @param filterStr
	 * @return
	 */
	public static String pinPersonSql( String type, String  filterStr ) {
		StringBuffer sbf = new StringBuffer();
		sbf.append(" /*dialect*/ SELECT     ");
		if(StringUtils.equals("count", type)) {
			sbf.append("  count( pers.fid )  pcount    ");
		}else if(StringUtils.equals("info", type)) {
			sbf.append("  pers.fid  fid,                       ");
			sbf.append("  pers.fnumber  number ,                       ");
			sbf.append("  pers.FName_L2  name   ,                ");
			sbf.append("  topp.FName_L2  posname ,                 ");
			sbf.append("  admOrg.FName_L2  depname                   ");
		}else if(StringUtils.equals("adminPerson", type)) {
			sbf.append("  count (pers.fid)  pcount,                    ");
			sbf.append("  admOrg.fid  depId                      ");
		}
		sbf.append(" FROM  t_bd_person pers                           ");
		sbf.append(" LEFT JOIN                                        ");
		sbf.append(" T_HR_EmpOrgRelation  rela                        ");
		sbf.append(" ON pers.fid = rela.fpersonid   ");
		sbf.append(" AND rela.FAssignType = 1   ");
		sbf.append(" AND rela. fleffdt = '2199-12-31 00:00:00'      ");
		sbf.append(" INNER JOIN  T_ORG_Position topp                  ");
		sbf.append(" ON rela.FPOSITIONID =  topp.fid                  ");
		sbf.append(" inner join T_HR_EmpLaborRelation labor           ");
		sbf.append(" ON rela.FlaborRelationID = labor.fid             ");
		sbf.append(" INNER JOIN T_ORG_Admin  admOrg   ");
		sbf.append(" ON topp.FAdminOrgUnitID = admOrg.fid   ");
		sbf.append(" where                      ");
		sbf.append("  labor.FLaborRelationStateID in (            ");
		sbf.append("  select fid from T_HR_BDEmployeeType where       ");
		sbf.append("  fname_l2 <> '' and  fname_l2 <> 'ְ'      ");
		sbf.append("  and  fname_l2 <> '' and  fname_l2 <> '' ");
		sbf.append("  and  fname_l2 <> 'Ƹ' and  fname_l2 <> 'ְ' ");
		sbf.append("  and  fname_l2 <> ''                        ");
		sbf.append("  )                                               ");
		if(!StringUtils.isEmpty(filterStr)) {
			sbf.append(filterStr);
		}
		if(StringUtils.equals("info", type)) {
			sbf.append(" order by  topp.FIsRespPosition  desc ,  pers.fnumber ");
		}else if(StringUtils.equals("adminPerson", type)) {
			sbf.append(" group by admOrg.fid ");
		 
		}
		
		return sbf.toString();
		
	}
}
